# doit-api

*`pydoit` for humans: an API to create `doit` tasks faster and more reliably.*

[![Python versions](https://img.shields.io/pypi/pyversions/doit-api.svg)](https://pypi.python.org/pypi/doit-api/) [![Build Status](https://travis-ci.org/smarie/python-doit-api.svg?branch=master)](https://travis-ci.org/smarie/python-doit-api) [![Tests Status](https://smarie.github.io/python-doit-api/junit/junit-badge.svg?dummy=8484744)](https://smarie.github.io/python-doit-api/junit/report.html) [![codecov](https://codecov.io/gh/smarie/python-doit-api/branch/master/graph/badge.svg)](https://codecov.io/gh/smarie/python-doit-api)

[![Documentation](https://img.shields.io/badge/doc-latest-blue.svg)](https://smarie.github.io/python-doit-api/) [![PyPI](https://img.shields.io/pypi/v/doit-api.svg)](https://pypi.python.org/pypi/doit-api/) [![Downloads](https://pepy.tech/badge/doit-api)](https://pepy.tech/project/doit-api) [![Downloads per week](https://pepy.tech/badge/doit-api/week)](https://pepy.tech/project/doit-api) [![GitHub stars](https://img.shields.io/github/stars/smarie/python-doit-api.svg)](https://github.com/smarie/python-doit-api/stargazers)


[`pydoit`](https://pydoit.org/) is a great automation tool, but it is a bit hard to develop fast with it unless knowing by heart all the naming conventions. Indeed it follows a "no api" philosophy, so you have to remember all names and supported types, going back and forth reading the documentation page.

Inspired by [`letsdoit`](https://pypi.org/project/letsdoit), `doit-api` proposes a few api symbols to help you develop faster and more reliably, thanks to IDE autocompletion, docstring display, and type hinting. 


## Installing

```bash
> pip install doit-api
```

## Usage

### Single task

TODO

### Task generator

TODO

## Main features / benefits

 * **Develop `doit` tasks faster and more reliably** thanks to you favourite python IDE's autocompletion and documentation features.

## See Also

 - [doit](https://pydoit.org/) of course
 - [fprules](https://smarie.github.io/python-fprules/) a library to help create `make`-like file pattern rules, quite handy for doit tasks. 
 - [letsdoit](https://pypi.org/project/letsdoit/) the project that inspired `doit-api`
 - other doit plugins: 
 
    - [doit-report](https://github.com/saimn/doit-report)
    - [doit-redis](https://github.com/saimn/doit-redis)
    - [doit-graph](https://github.com/pydoit/doit-graph)
    - [doit-py](https://pythonhosted.org/doit-py/)
    - [doit-cmd](https://pythonhosted.org/doit-cmd/)

 - [celery](https://docs.celeryproject.org), another generic asynchronous task engine
 - [nox](https://nox.thea.codes), another task engine oriented towards build/test

### Others

*Do you like this library ? You might also like [my other python libraries](https://github.com/smarie/OVERVIEW#python)* 

## Want to contribute ?

Details on the github page: [https://github.com/smarie/python-doit-api](https://github.com/smarie/python-doit-api)
